#pragma once

#include "../Leadwerks.h"

namespace Leadwerks
{
	class Texture;
	class Character;
	class Asset;

	class Font : public Asset//lua
	{
	public:
#ifdef LEADWERKS_5
		shared_ptr<Texture> texture;
		std::map<int, shared_ptr<Character> > character;
		std::wstring familychars;
#else
		Texture* texture;
		std::map<int, Character*> character;
		std::string familychars;
#endif
		FT_Face face;
        int height;
		bool faceinitialized;
		int textureatlasx;
		int textureatlasy;
		int textureatlasmaxy;
		int style;
		int size;
		bool vertical;
		int family;

		Font();
		virtual ~Font();

		virtual std::string GetClassName();
		virtual bool BuildAtlas();
		virtual int GetTextWidth(const std::string& text);//lua
        virtual int GetHeight();//lua
		virtual bool Reload(const int flags=0);
#ifdef LEADWERKS_5
		virtual int GetTextWidth(const std::wstring& text);
		virtual void DrawText(const std::wstring& text, const float x, const float y, const float kerning = 0);
		virtual bool Reload(shared_ptr<Stream> stream, const int flags = 0);
		virtual shared_ptr<Asset> Copy();
		virtual shared_ptr<Texture> GetTexture();
		virtual shared_ptr<Character> LoadChar(const int c, const bool force = false);
#else
		virtual void DrawText(const std::wstring text, const float x, const float y, const float kerning = 0);
		virtual void DrawText(const std::string& text, const float x, const float y, const float kerning = 0);//lua
		virtual bool Reload(Stream* stream, const int flags = 0);
		virtual Asset* Copy();
		virtual Texture* GetTexture();
		virtual Character* LoadChar(const int c, const bool force = false);
#endif
		virtual void Reset();

        static const int Pixel;//lua
        static const int Smooth;//lua
        static const int LCD;//lua
        static const int English;//lua

		static const std::string defaultfamilychars;

#ifndef LEADWERKS_5
		static Font* Load(const std::string& path, const int size, const int style = Font::Smooth, const int family = Font::English, const int flags = 0, const uint64_t fileid=0);//lua
		static Font* Load(Stream* stream, const int size, const int style = Font::Smooth, const int family = Font::English, const int flags=0);//lua
		static Font* Load(const std::string& path, const int size, const int style, const std::string& familychars, const int flags=0);//lua
#endif
	};
#ifdef LEADWERKS_5
	extern shared_ptr<Font> LoadFont(const std::string& path, const int size, const int style = Font::Smooth, const std::string& familychars = "", const int flags = 0);
	extern shared_ptr<Font> LoadFont(const std::wstring& path, const int size, const int style = Font::Smooth, const std::wstring& familychars = L"", const int flags = 0);
#endif
}
